## libcds-pubsub 0.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}")
include(pub_sub_version)
set (PROJECT_SHORT_NAME cds-pubsub)
get_pub_sub_version(PUB_SUB_PROJECT_VERSION_STR)
get_pub_sub_version_tag(PUB_SUB_PROJECT_VERSION_TAG)
project(lib${PROJECT_SHORT_NAME} VERSION ${PUB_SUB_PROJECT_VERSION_STR})

get_debian_version(deb_ver)
message(STATUS "Project version = ${PUB_SUB_PROJECT_VERSION_STR}${PUB_SUB_PROJECT_VERSION_TAG}" )
message(STATUS "Debian  version = ${deb_ver}")
if (NOT "${deb_ver}" STREQUAL "${PUB_SUB_PROJECT_VERSION_STR}${PUB_SUB_PROJECT_VERSION_TAG}")
    MESSAGE(FATAL_ERROR "The debian package version is out of sync with the project version")
endif()



set(CMAKE_CXX_STANDARD 14)

enable_testing()

include(CMakePackageConfigHelpers)

find_package(Boost REQUIRED system)
find_package(pybind11 REQUIRED)
find_package(Threads)
include(FindZStd)

install(FILES COPYING README.md
        DESTINATION share/doc/${CMAKE_PROJECT_NAME}
        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )

add_subdirectory(external)
add_subdirectory(pub_sub)
add_subdirectory(python)
add_subdirectory(examples)

=== examples/CMakeLists.txt ===
add_executable(publisher publisher.cc)
target_link_libraries(publisher PUBLIC pub_sub_asan)

add_executable(subscriber subscriber.cc)
target_link_libraries(subscriber PUBLIC pub_sub_asan)

# the main examples are built with sanitizer support
# do a build to make sure it can build w/o sanitizers
add_executable(publisher_nosan publisher.cc)
target_link_libraries(publisher_nosan PUBLIC pub_sub)

=== pub_sub/CMakeLists.txt ===
# taken from the nds client library
# Notes from autotools version mythbuster
# https://autotools.io/libtool/version.html
# Warning
# A common mistake is to assume that the three values passed to -version-info
# map directly into the three numbers at the end of the library name. This is
# not the case, and indeed, current, revision and age are applied differently
# depending on the operating system that one is using.
#
# For Linux, for instance, while the last two values map directly from the
# command-line, the first is calculated by subtracting age from current. On
# the other hand, on modern FreeBSD, only one component is used in the library
# version, which corresponds to current.
#
# The rules of thumb, when dealing with these values are:
#
#    Always increase the revision value.
#    Increase the current value whenever an interface has been added, removed or changed.
#    Increase the age value only if the changes made to the ABI are backward compatible.
#========================================================================
# CALCULATE_LIBTOOL_VERSION
#
# library_name = Variable to set with the swig property value
# current      = Property to be queried
# revision     = SWIG target to query
# age          =
#------------------------------------------------------------------------
function( NDS_LIBTOOL_VERSION_CALCULATION library_name current revision age )
    math( EXPR ${library_name}_VERSION_MAJOR "${current} - ${age}" )
    set( ${library_name}_VERSION_MAJOR ${${library_name}_VERSION_MAJOR}
            PARENT_SCOPE )
    set( ${library_name}_VERSION_MINOR ${age} PARENT_SCOPE )
    set( ${library_name}_VERSION_MICRO ${revision} PARENT_SCOPE )
    set( ${library_name}_VERSION
            ${${library_name}_VERSION_MAJOR}.${age}.${revision}
            PARENT_SCOPE )
    set( ${library_name}_SOVERSION
            ${${library_name}_VERSION_MAJOR}
            PARENT_SCOPE )
endfunction( NDS_LIBTOOL_VERSION_CALCULATION )

configure_file( include/cds-pubsub/version.hh.in
        "${CMAKE_CURRENT_BINARY_DIR}/include/cds-pubsub/version.hh"
        @ONLY )

set( PUB_SUB_SOVERSION_CURRENT 1 )
set( PUB_SUB_SOVERSION_REVISION 2 )
set( PUB_SUB_SOVERSION_AGE 1 )
nds_libtool_version_calculation( PUB_SUB ${PUB_SUB_SOVERSION_CURRENT}
        ${PUB_SUB_SOVERSION_REVISION}
        ${PUB_SUB_SOVERSION_AGE})
message("Version = ${PUB_SUB_VERSION}")
message("SOVersion = ${PUB_SUB_SOVERSION}")

set (PUB_SUB_SRC
        common.cc
        pub.cc
        sub.cc
        pipeline_parser.cc
        )

add_library(pub_sub SHARED
        ${PUB_SUB_SRC}
)
target_include_directories(pub_sub PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/private")
target_include_directories(pub_sub PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )
target_link_libraries(pub_sub PUBLIC
        Boost::boost
        Boost::system
        Threads::Threads
        zstd::zstd
        )

set(PUBLIC_HEADERS include/cds-pubsub/common.hh
        include/cds-pubsub/pub.hh
        include/cds-pubsub/pub_plugin.hh
        include/cds-pubsub/sub.hh
        include/cds-pubsub/sub_plugin.hh
        "${CMAKE_CURRENT_BINARY_DIR}/include/cds-pubsub/version.hh"
)
set_target_properties(pub_sub PROPERTIES
        PUBLIC_HEADER "${PUBLIC_HEADERS}"
        OUTPUT_NAME cds-pubsub
        VERSION ${PUB_SUB_VERSION}
        SOVERSION ${PUB_SUB_SOVERSION}
        )

add_library(pub_sub_asan
        ${PUB_SUB_SRC}
        )
target_compile_options(pub_sub_asan PUBLIC "-fsanitize=address")
target_include_directories(pub_sub_asan PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/private")
target_include_directories(pub_sub_asan PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:include>
        )
target_link_libraries(pub_sub_asan PRIVATE
        asan
        Boost::boost
        Boost::system
        Threads::Threads
        zstd::zstd
        )
set_target_properties(pub_sub_asan PROPERTIES
        OUTPUT_NAME cds-pubsub-asan
        VERSION ${PUB_SUB_VERSION}
        SOVERSION ${PUB_SUB_SOVERSION}
        )

install(TARGETS pub_sub pub_sub_asan
        EXPORT libcds-pubsubConfig
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        PUBLIC_HEADER DESTINATION include/${PROJECT_SHORT_NAME}
        )

write_basic_package_version_file(
        libcds-pubsubConfigVersion.cmake
        VERSION ${PACKAGE_VERSION}
        COMPATIBILITY AnyNewerVersion
)
install(FILES ${CMAKE_SOURCE_DIR}/cmake/FindZStd.cmake
        DESTINATION share/${CMAKE_PROJECT_NAME}/cmake
)
install(FILES libcds-pubsubConfig.cmake
        DESTINATION share/${CMAKE_PROJECT_NAME}/cmake
)
install(EXPORT libcds-pubsubConfig DESTINATION share/${CMAKE_PROJECT_NAME}/cmake
        NAMESPACE cds::
        FILE libcds-pubsub_generated.cmake
        EXPORT_LINK_INTERFACE_LIBRARIES)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libcds-pubsubConfigVersion.cmake
        DESTINATION share/${CMAKE_PROJECT_NAME}/cmake)

configure_file(tests/test_version.cc.in "${CMAKE_CURRENT_BINARY_DIR}/tests/test_version.cc" @ONLY)

set(TEST_SRC
    tests/test_common.cc
    tests/test_full_subscription_internal.cc
    tests/test_main.cc
    tests/test_pub_iface.cc
    tests/test_sub_iface.cc
    tests/test_zlib_common.cc
    tests/test_pipeline_parser.cc
    ${CMAKE_CURRENT_BINARY_DIR}/tests/test_version.cc
    )

add_executable(test_sender tests/test_sender.cc)
target_link_libraries(test_sender PUBLIC pub_sub)

add_executable(test_slow_receiver tests/test_slow_receiver.cc)
target_link_libraries(test_slow_receiver PUBLIC pub_sub)

add_executable(test_pub_sub
        ${TEST_SRC})
target_include_directories(test_pub_sub PUBLIC
        private
        tests)
target_link_libraries(test_pub_sub PUBLIC pub_sub catch2)

add_executable(test_pub_sub_asan
        ${TEST_SRC})
target_include_directories(test_pub_sub_asan PUBLIC
        private
        tests)
target_link_libraries(test_pub_sub_asan PUBLIC pub_sub_asan catch2)

add_test(NAME test_pub_sub COMMAND test_pub_sub
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

add_test(NAME test_pub_sub_asan COMMAND test_pub_sub
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

=== python/CMakeLists.txt ===
pybind11_add_module(pubsub pub_sub_python.cc)
target_link_libraries(pubsub PRIVATE pub_sub)

install(TARGETS pubsub
        LIBRARY DESTINATION lib/python3/dist-packages
        ARCHIVE DESTINATION lib/python3/dist-packages
        )

=== external/catch2/CMakeLists.txt ===
if (TARGET catch2)
    message("Catch2 already defined, assuming this is from an external  include")
else (TARGET catch2)
    add_library(catch2 INTERFACE)
    target_include_directories(catch2 INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
endif(TARGET catch2)

=== debian/changelog ===
libcds-pubsub (0.3.2) unstable; urgency=medium

  * Changes to build under Debian bullseye and buster

 -- Jonathan Hanks <jhanks@caltech.edu>  Tue, 17 Aug 2021 21:07:57 -0700

libcds-pubsub (0.3.1) unstable; urgency=medium

  * Updates to the cmake dependencies

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 02 Aug 2021 17:31:35 -0700

libcds-pubsub (0.3.0) unstable; urgency=medium

  * Added support for setting up pipelines of pub/sub objects.
  * Added a compression pub/sub mechanism based around zstd. 

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Mon, 02 Aug 2021 14:04:58 -0700

libcds-pubsub (0.2.0) unstable; urgency=medium

  * Adding support for restarting subscriptions (this only works on tcp).

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Thu, 08 Oct 2020 09:54:11 -0700

libcds-pubsub (0.1.0) unstable; urgency=medium

  * Added a plugin interface for publishers and subscribers. 

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Sat, 11 Apr 2020 08:59:21 -0700

libcds-pubsub (0.0.0) unstable; urgency=medium

  * Initial Release.

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Wed, 04 Mar 2020 13:03:52 -0800

=== debian/control ===
Source: libcds-pubsub
Priority: optional
Maintainer: Jonathan Hanks <jonathan.hanks@ligo.org>
Build-Depends:
 debhelper (>= 11),
 devscripts,
 dpkg-dev,
 equivs,
 build-essential,
 cmake,
 libboost-dev,
 libboost-system-dev,
 python3-all-dev,
 python3-all,
 pybind11-dev,
 libzstd-dev,
Standards-Version: 4.1.3
Section: libs
Homepage: https://git.ligo.org/cds/pub_sub
#Vcs-Browser: https://salsa.debian.org/debian/libcds-pubsub
#Vcs-Git: https://salsa.debian.org/debian/libcds-pubsub.git

Package: libcds-pubsub-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcds-pubsub (= ${binary:Version}), ${misc:Depends}
Description: A simple ip based publisher/subscriber system.
 A simple publisher/subscriber system build for the LIGO cds systems.
 .
 Provides facilities for doing:
  * tcp unicast
  * udp broadcast with support for retransmitting lost data
  * udp multicast with support for retransmitting lost data
 .
 This package contains the development files to use libcds-pubsub

Package: libcds-pubsub
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A simple ip based publisher/subscriber system.
 A simple publisher/subscriber system build for the LIGO cds systems.
 .
 Provides facilities for doing:
  * tcp unicast
  * udp broadcast with support for retransmitting lost data
  * udp multicast with support for retransmitting lost data

Package: python3-cds-pubsub
Architecture: any
Multi-Arch: same
Depends: libcds-pubsub (= ${binary:Version}), ${misc:Depends}
Description: A python3 wrapper over the cds-pubsub library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
